class
	APPLICATION
	
inherit
	AFX_INTERPRETER
	
create
	make
		
		
feature{NONE} -- Implementation

	mark_test_case (a_recipient_class: STRING; a_recipient: STRING; a_exception_code: INTEGER; a_bpslot: INTEGER; a_tag: STRING; a_passing: BOOLEAN; a_test_case_number: INTEGER; a_dry_run: BOOLEAN; a_uuid: STRING; a_trace: STRING)
			-- If `a_dry_run' is True, states of the current system should not be retrieved.
		do
			do_nothing
		end

	initialize_test_cases
			-- Initialize `test_cases'.
		do
			create test_cases.make (15)
			test_cases.compare_objects
			test_cases.extend (agent execute_test_case_2, "12646974421549005")
			test_cases.extend (agent execute_test_case_3, "1264691436572887")
			test_cases.extend (agent execute_test_case_4, "126469387178810")
			test_cases.extend (agent execute_test_case_5, "1264688893913386")
			test_cases.extend (agent execute_test_case_6, "1264688877897165")
			test_cases.extend (agent execute_test_case_7, "12646974221538963")
			test_cases.extend (agent execute_test_case_8, "12646892931233870")
			test_cases.extend (agent execute_test_case_9, "1264688881900307")
			test_cases.extend (agent execute_test_case_10, "1264688878898026")
			test_cases.extend (agent execute_test_case_11, "1264691145407659")
			test_cases.extend (agent execute_test_case_12, "126469386675946")
			test_cases.extend (agent execute_test_case_13, "1264691433569713")
			test_cases.extend (agent execute_test_case_14, "1264691455588202")
			test_cases.extend (agent execute_test_case_15, "126469384569078")
			test_cases.extend (agent execute_test_case_16, "1264691157416363")
		end


	operand_states (a_operands: SPECIAL [detachable ANY]):  like state_type
		local
			l_queries: HASH_TABLE [HASH_TABLE [FUNCTION [ANY, TUPLE, ANY], STRING], INTEGER]
			l_tbl: HASH_TABLE [FUNCTION [ANY, TUPLE, ANY], STRING]
		do
			create l_queries.make (a_operands.count)
			if attached {ARRAYED_LIST [?ANY]} a_operands.item (0) as l_operand_0 then
				create l_tbl.make (19)
				l_tbl.compare_objects
				l_queries.put (l_tbl, 0)
				l_tbl.put (agent l_operand_0.after, "after")
				l_tbl.put (agent l_operand_0.all_default, "all_default")
				l_tbl.put (agent l_operand_0.before, "before")
				l_tbl.put (agent l_operand_0.capacity, "capacity")
				l_tbl.put (agent l_operand_0.changeable_comparison_criterion, "changeable_comparison_criterion")
				l_tbl.put (agent l_operand_0.count, "count")
				l_tbl.put (agent l_operand_0.empty, "empty")
				l_tbl.put (agent l_operand_0.exhausted, "exhausted")
				l_tbl.put (agent l_operand_0.extendible, "extendible")
				l_tbl.put (agent l_operand_0.full, "full")
				l_tbl.put (agent l_operand_0.index, "index")
				l_tbl.put (agent l_operand_0.is_empty, "is_empty")
				l_tbl.put (agent l_operand_0.isfirst, "isfirst")
				l_tbl.put (agent l_operand_0.islast, "islast")
				l_tbl.put (agent l_operand_0.object_comparison, "object_comparison")
				l_tbl.put (agent l_operand_0.off, "off")
				l_tbl.put (agent l_operand_0.prunable, "prunable")
				l_tbl.put (agent l_operand_0.readable, "readable")
				l_tbl.put (agent l_operand_0.writable, "writable")
			else
				create l_tbl.make (0)
				l_tbl.compare_objects
				l_queries.put (l_tbl, 0)
			end
			if attached {INTEGER_32} a_operands.item (1) as l_operand_1 then
				create l_tbl.make (1)
				l_tbl.compare_objects
				l_queries.put (l_tbl, 1)
				l_tbl.put (agent (l_value: INTEGER_32): INTEGER_32 do Result := l_value end (l_operand_1), "item")
			else
				create l_tbl.make (0)
				l_tbl.compare_objects
				l_queries.put (l_tbl, 1)
			end
			Result := object_states (l_queries)
		end


	first_failing_test_case_uuid: STRING
		do
			Result := "12646974421549005"
		end



	execute_test_cases
			--Execute test cases.
		do
			execute_test_case_1
			execute_test_case_2
			execute_test_case_3
			execute_test_case_4
			execute_test_case_5
			execute_test_case_6
			execute_test_case_7
			execute_test_case_8
			execute_test_case_9
			execute_test_case_10
			execute_test_case_11
			execute_test_case_12
			execute_test_case_13
			execute_test_case_14
			execute_test_case_15
			execute_test_case_16
		end


feature{NONE} -- Implementation

	execute_test_case_1
	local
		l_tc: TC__ARRAYED_LIST__resize__F__c6__b3__REC_ARRAYED_LIST__resize__TAG_empty_means_storage_empty__12646974421549005
		l_retried: BOOLEAN
	do
		if not l_retried then
			create l_tc
			mark_test_case ("ARRAYED_LIST", "resize", 6, 3, "empty_means_storage_empty", False, 1, True, "12646974421549005", l_tc.exception_trace_string)					
			l_tc.setup
			retrieve_pre_state (l_tc.operands)
			l_tc.generated_test_1
			retrieve_post_state (l_tc.operands)
		end
	rescue
		exception_count := exception_count + 1
		l_retried := True
		retry
	end

	execute_test_case_2
	local
		l_tc: TC__ARRAYED_LIST__resize__F__c6__b3__REC_ARRAYED_LIST__resize__TAG_empty_means_storage_empty__12646974421549005
		l_retried: BOOLEAN
	do
		if not l_retried then
			create l_tc
			mark_test_case ("ARRAYED_LIST", "resize", 6, 3, "empty_means_storage_empty", False, 2, False, "12646974421549005", l_tc.exception_trace_string)					
			l_tc.setup
			retrieve_pre_state (l_tc.operands)
			l_tc.generated_test_1
			retrieve_post_state (l_tc.operands)
		end
	rescue
		exception_count := exception_count + 1
		l_retried := True
		retry
	end

	execute_test_case_3
	local
		l_tc: TC__ARRAYED_LIST__resize__F__c6__b3__REC_ARRAYED_LIST__resize__TAG_empty_means_storage_empty__1264691436572887
		l_retried: BOOLEAN
	do
		if not l_retried then
			create l_tc
			mark_test_case ("ARRAYED_LIST", "resize", 6, 3, "empty_means_storage_empty", False, 3, False, "1264691436572887", l_tc.exception_trace_string)					
			l_tc.setup
			retrieve_pre_state (l_tc.operands)
			l_tc.generated_test_1
			retrieve_post_state (l_tc.operands)
		end
	rescue
		exception_count := exception_count + 1
		l_retried := True
		retry
	end

	execute_test_case_4
	local
		l_tc: TC__ARRAYED_LIST__resize__F__c6__b3__REC_ARRAYED_LIST__resize__TAG_empty_means_storage_empty__126469387178810
		l_retried: BOOLEAN
	do
		if not l_retried then
			create l_tc
			mark_test_case ("ARRAYED_LIST", "resize", 6, 3, "empty_means_storage_empty", False, 4, False, "126469387178810", l_tc.exception_trace_string)					
			l_tc.setup
			retrieve_pre_state (l_tc.operands)
			l_tc.generated_test_1
			retrieve_post_state (l_tc.operands)
		end
	rescue
		exception_count := exception_count + 1
		l_retried := True
		retry
	end

	execute_test_case_5
	local
		l_tc: TC__ARRAYED_LIST__resize__S__c0__b0__REC_ARRAYED_LIST__resize__TAG_noname__1264688893913386
		l_retried: BOOLEAN
	do
		if not l_retried then
			create l_tc
			mark_test_case ("ARRAYED_LIST", "resize", 6, 3, "empty_means_storage_empty", True, 5, False, "1264688893913386", l_tc.exception_trace_string)					
			l_tc.setup
			retrieve_pre_state (l_tc.operands)
			l_tc.generated_test_1
			retrieve_post_state (l_tc.operands)
		end
	rescue
		exception_count := exception_count + 1
		l_retried := True
		retry
	end

	execute_test_case_6
	local
		l_tc: TC__ARRAYED_LIST__resize__S__c0__b0__REC_ARRAYED_LIST__resize__TAG_noname__1264688877897165
		l_retried: BOOLEAN
	do
		if not l_retried then
			create l_tc
			mark_test_case ("ARRAYED_LIST", "resize", 6, 3, "empty_means_storage_empty", True, 6, False, "1264688877897165", l_tc.exception_trace_string)					
			l_tc.setup
			retrieve_pre_state (l_tc.operands)
			l_tc.generated_test_1
			retrieve_post_state (l_tc.operands)
		end
	rescue
		exception_count := exception_count + 1
		l_retried := True
		retry
	end

	execute_test_case_7
	local
		l_tc: TC__ARRAYED_LIST__resize__S__c0__b0__REC_ARRAYED_LIST__resize__TAG_noname__12646974221538963
		l_retried: BOOLEAN
	do
		if not l_retried then
			create l_tc
			mark_test_case ("ARRAYED_LIST", "resize", 6, 3, "empty_means_storage_empty", True, 7, False, "12646974221538963", l_tc.exception_trace_string)					
			l_tc.setup
			retrieve_pre_state (l_tc.operands)
			l_tc.generated_test_1
			retrieve_post_state (l_tc.operands)
		end
	rescue
		exception_count := exception_count + 1
		l_retried := True
		retry
	end

	execute_test_case_8
	local
		l_tc: TC__ARRAYED_LIST__resize__S__c0__b0__REC_ARRAYED_LIST__resize__TAG_noname__12646892931233870
		l_retried: BOOLEAN
	do
		if not l_retried then
			create l_tc
			mark_test_case ("ARRAYED_LIST", "resize", 6, 3, "empty_means_storage_empty", True, 8, False, "12646892931233870", l_tc.exception_trace_string)					
			l_tc.setup
			retrieve_pre_state (l_tc.operands)
			l_tc.generated_test_1
			retrieve_post_state (l_tc.operands)
		end
	rescue
		exception_count := exception_count + 1
		l_retried := True
		retry
	end

	execute_test_case_9
	local
		l_tc: TC__ARRAYED_LIST__resize__S__c0__b0__REC_ARRAYED_LIST__resize__TAG_noname__1264688881900307
		l_retried: BOOLEAN
	do
		if not l_retried then
			create l_tc
			mark_test_case ("ARRAYED_LIST", "resize", 6, 3, "empty_means_storage_empty", True, 9, False, "1264688881900307", l_tc.exception_trace_string)					
			l_tc.setup
			retrieve_pre_state (l_tc.operands)
			l_tc.generated_test_1
			retrieve_post_state (l_tc.operands)
		end
	rescue
		exception_count := exception_count + 1
		l_retried := True
		retry
	end

	execute_test_case_10
	local
		l_tc: TC__ARRAYED_LIST__resize__S__c0__b0__REC_ARRAYED_LIST__resize__TAG_noname__1264688878898026
		l_retried: BOOLEAN
	do
		if not l_retried then
			create l_tc
			mark_test_case ("ARRAYED_LIST", "resize", 6, 3, "empty_means_storage_empty", True, 10, False, "1264688878898026", l_tc.exception_trace_string)					
			l_tc.setup
			retrieve_pre_state (l_tc.operands)
			l_tc.generated_test_1
			retrieve_post_state (l_tc.operands)
		end
	rescue
		exception_count := exception_count + 1
		l_retried := True
		retry
	end

	execute_test_case_11
	local
		l_tc: TC__ARRAYED_LIST__resize__S__c0__b0__REC_ARRAYED_LIST__resize__TAG_noname__1264691145407659
		l_retried: BOOLEAN
	do
		if not l_retried then
			create l_tc
			mark_test_case ("ARRAYED_LIST", "resize", 6, 3, "empty_means_storage_empty", True, 11, False, "1264691145407659", l_tc.exception_trace_string)					
			l_tc.setup
			retrieve_pre_state (l_tc.operands)
			l_tc.generated_test_1
			retrieve_post_state (l_tc.operands)
		end
	rescue
		exception_count := exception_count + 1
		l_retried := True
		retry
	end

	execute_test_case_12
	local
		l_tc: TC__ARRAYED_LIST__resize__S__c0__b0__REC_ARRAYED_LIST__resize__TAG_noname__126469386675946
		l_retried: BOOLEAN
	do
		if not l_retried then
			create l_tc
			mark_test_case ("ARRAYED_LIST", "resize", 6, 3, "empty_means_storage_empty", True, 12, False, "126469386675946", l_tc.exception_trace_string)					
			l_tc.setup
			retrieve_pre_state (l_tc.operands)
			l_tc.generated_test_1
			retrieve_post_state (l_tc.operands)
		end
	rescue
		exception_count := exception_count + 1
		l_retried := True
		retry
	end

	execute_test_case_13
	local
		l_tc: TC__ARRAYED_LIST__resize__S__c0__b0__REC_ARRAYED_LIST__resize__TAG_noname__1264691433569713
		l_retried: BOOLEAN
	do
		if not l_retried then
			create l_tc
			mark_test_case ("ARRAYED_LIST", "resize", 6, 3, "empty_means_storage_empty", True, 13, False, "1264691433569713", l_tc.exception_trace_string)					
			l_tc.setup
			retrieve_pre_state (l_tc.operands)
			l_tc.generated_test_1
			retrieve_post_state (l_tc.operands)
		end
	rescue
		exception_count := exception_count + 1
		l_retried := True
		retry
	end

	execute_test_case_14
	local
		l_tc: TC__ARRAYED_LIST__resize__S__c0__b0__REC_ARRAYED_LIST__resize__TAG_noname__1264691455588202
		l_retried: BOOLEAN
	do
		if not l_retried then
			create l_tc
			mark_test_case ("ARRAYED_LIST", "resize", 6, 3, "empty_means_storage_empty", True, 14, False, "1264691455588202", l_tc.exception_trace_string)					
			l_tc.setup
			retrieve_pre_state (l_tc.operands)
			l_tc.generated_test_1
			retrieve_post_state (l_tc.operands)
		end
	rescue
		exception_count := exception_count + 1
		l_retried := True
		retry
	end

	execute_test_case_15
	local
		l_tc: TC__ARRAYED_LIST__resize__S__c0__b0__REC_ARRAYED_LIST__resize__TAG_noname__126469384569078
		l_retried: BOOLEAN
	do
		if not l_retried then
			create l_tc
			mark_test_case ("ARRAYED_LIST", "resize", 6, 3, "empty_means_storage_empty", True, 15, False, "126469384569078", l_tc.exception_trace_string)					
			l_tc.setup
			retrieve_pre_state (l_tc.operands)
			l_tc.generated_test_1
			retrieve_post_state (l_tc.operands)
		end
	rescue
		exception_count := exception_count + 1
		l_retried := True
		retry
	end

	execute_test_case_16
	local
		l_tc: TC__ARRAYED_LIST__resize__S__c0__b0__REC_ARRAYED_LIST__resize__TAG_noname__1264691157416363
		l_retried: BOOLEAN
	do
		if not l_retried then
			create l_tc
			mark_test_case ("ARRAYED_LIST", "resize", 6, 3, "empty_means_storage_empty", True, 16, False, "1264691157416363", l_tc.exception_trace_string)					
			l_tc.setup
			retrieve_pre_state (l_tc.operands)
			l_tc.generated_test_1
			retrieve_post_state (l_tc.operands)
		end
	rescue
		exception_count := exception_count + 1
		l_retried := True
		retry
	end



end
