class
	APPLICATION
	
inherit
	AFX_INTERPRETER
	
create
	make
		
		
feature{NONE} -- Implementation

	mark_test_case (a_recipient_class: STRING; a_recipient: STRING; a_exception_code: INTEGER; a_bpslot: INTEGER; a_tag: STRING; a_passing: BOOLEAN; a_test_case_number: INTEGER; a_dry_run: BOOLEAN; a_uuid: STRING; a_trace: STRING)
			-- If `a_dry_run' is True, states of the current system should not be retrieved.
		do
			do_nothing
		end

	initialize_test_cases
			-- Initialize `test_cases'.
		do
			create test_cases.make (9)
			test_cases.compare_objects
			test_cases.extend (agent execute_test_case_2, "1264688040204995")
			test_cases.extend (agent execute_test_case_3, "1264694308274485")
			test_cases.extend (agent execute_test_case_4, "126468788045451")
			test_cases.extend (agent execute_test_case_5, "12646922401019375")
			test_cases.extend (agent execute_test_case_6, "1264694304272145")
			test_cases.extend (agent execute_test_case_7, "126468787641716")
			test_cases.extend (agent execute_test_case_8, "12646926501248582")
			test_cases.extend (agent execute_test_case_9, "126468787843663")
			test_cases.extend (agent execute_test_case_10, "126468787439816")
		end


	operand_states (a_operands: SPECIAL [detachable ANY]):  like state_type
		local
			l_queries: HASH_TABLE [HASH_TABLE [FUNCTION [ANY, TUPLE, ANY], STRING], INTEGER]
			l_tbl: HASH_TABLE [FUNCTION [ANY, TUPLE, ANY], STRING]
		do
			create l_queries.make (a_operands.count)
			if attached {DS_INDEXABLE [?ANY]} a_operands.item (0) as l_operand_0 then
				create l_tbl.make (3)
				l_tbl.compare_objects
				l_queries.put (l_tbl, 0)
				l_tbl.put (agent l_operand_0.count, "count")
				l_tbl.put (agent l_operand_0.has_void, "has_void")
				l_tbl.put (agent l_operand_0.is_empty, "is_empty")
			else
				create l_tbl.make (0)
				l_tbl.compare_objects
				l_queries.put (l_tbl, 0)
			end
			if attached {PROCEDURE [?ANY, ?TUPLE]} a_operands.item (1) as l_operand_1 then
				create l_tbl.make (5)
				l_tbl.compare_objects
				l_queries.put (l_tbl, 1)
				l_tbl.put (agent l_operand_1.callable, "callable")
				l_tbl.put (agent l_operand_1.hash_code, "hash_code")
				l_tbl.put (agent l_operand_1.is_hashable, "is_hashable")
				l_tbl.put (agent l_operand_1.is_target_closed, "is_target_closed")
				l_tbl.put (agent l_operand_1.open_count, "open_count")
			else
				create l_tbl.make (0)
				l_tbl.compare_objects
				l_queries.put (l_tbl, 1)
			end
			if attached {FUNCTION [?ANY, ?TUPLE, ?ANY]} a_operands.item (2) as l_operand_2 then
				create l_tbl.make (5)
				l_tbl.compare_objects
				l_queries.put (l_tbl, 2)
				l_tbl.put (agent l_operand_2.callable, "callable")
				l_tbl.put (agent l_operand_2.hash_code, "hash_code")
				l_tbl.put (agent l_operand_2.is_hashable, "is_hashable")
				l_tbl.put (agent l_operand_2.is_target_closed, "is_target_closed")
				l_tbl.put (agent l_operand_2.open_count, "open_count")
			else
				create l_tbl.make (0)
				l_tbl.compare_objects
				l_queries.put (l_tbl, 2)
			end
			Result := object_states (l_queries)
		end


	first_failing_test_case_uuid: STRING
		do
			Result := "1264688040204995"
		end



	execute_test_cases
			--Execute test cases.
		do
			execute_test_case_1
			execute_test_case_2
			execute_test_case_3
			execute_test_case_4
			execute_test_case_5
			execute_test_case_6
			execute_test_case_7
			execute_test_case_8
			execute_test_case_9
			execute_test_case_10
		end


feature{NONE} -- Implementation

	execute_test_case_1
	local
		l_tc: TC__DS_ARRAYED_LIST__do_if__F__c3__b1__REC_DS_INDEXABLE__do_if__TAG_valid_operands__1264688040204995
		l_retried: BOOLEAN
	do
		if not l_retried then
			create l_tc
			mark_test_case ("DS_INDEXABLE", "do_if", 3, 1, "valid_operands", False, 1, True, "1264688040204995", l_tc.exception_trace_string)					
			l_tc.setup
			retrieve_pre_state (l_tc.operands)
			l_tc.generated_test_1
			retrieve_post_state (l_tc.operands)
		end
	rescue
		exception_count := exception_count + 1
		l_retried := True
		retry
	end

	execute_test_case_2
	local
		l_tc: TC__DS_ARRAYED_LIST__do_if__F__c3__b1__REC_DS_INDEXABLE__do_if__TAG_valid_operands__1264688040204995
		l_retried: BOOLEAN
	do
		if not l_retried then
			create l_tc
			mark_test_case ("DS_INDEXABLE", "do_if", 3, 1, "valid_operands", False, 2, False, "1264688040204995", l_tc.exception_trace_string)					
			l_tc.setup
			retrieve_pre_state (l_tc.operands)
			l_tc.generated_test_1
			retrieve_post_state (l_tc.operands)
		end
	rescue
		exception_count := exception_count + 1
		l_retried := True
		retry
	end

	execute_test_case_3
	local
		l_tc: TC__DS_ARRAYED_LIST__do_if__F__c3__b1__REC_DS_INDEXABLE__do_if__TAG_valid_operands__1264694308274485
		l_retried: BOOLEAN
	do
		if not l_retried then
			create l_tc
			mark_test_case ("DS_INDEXABLE", "do_if", 3, 1, "valid_operands", False, 3, False, "1264694308274485", l_tc.exception_trace_string)					
			l_tc.setup
			retrieve_pre_state (l_tc.operands)
			l_tc.generated_test_1
			retrieve_post_state (l_tc.operands)
		end
	rescue
		exception_count := exception_count + 1
		l_retried := True
		retry
	end

	execute_test_case_4
	local
		l_tc: TC__DS_ARRAYED_LIST__do_if__F__c3__b1__REC_DS_INDEXABLE__do_if__TAG_valid_operands__126468788045451
		l_retried: BOOLEAN
	do
		if not l_retried then
			create l_tc
			mark_test_case ("DS_INDEXABLE", "do_if", 3, 1, "valid_operands", False, 4, False, "126468788045451", l_tc.exception_trace_string)					
			l_tc.setup
			retrieve_pre_state (l_tc.operands)
			l_tc.generated_test_1
			retrieve_post_state (l_tc.operands)
		end
	rescue
		exception_count := exception_count + 1
		l_retried := True
		retry
	end

	execute_test_case_5
	local
		l_tc: TC__DS_ARRAYED_LIST__do_if__F__c3__b1__REC_DS_INDEXABLE__do_if__TAG_valid_operands__12646922401019375
		l_retried: BOOLEAN
	do
		if not l_retried then
			create l_tc
			mark_test_case ("DS_INDEXABLE", "do_if", 3, 1, "valid_operands", False, 5, False, "12646922401019375", l_tc.exception_trace_string)					
			l_tc.setup
			retrieve_pre_state (l_tc.operands)
			l_tc.generated_test_1
			retrieve_post_state (l_tc.operands)
		end
	rescue
		exception_count := exception_count + 1
		l_retried := True
		retry
	end

	execute_test_case_6
	local
		l_tc: TC__DS_ARRAYED_LIST__do_if__S__c0__b0__REC_DS_ARRAYED_LIST__do_if__TAG_noname__1264694304272145
		l_retried: BOOLEAN
	do
		if not l_retried then
			create l_tc
			mark_test_case ("DS_INDEXABLE", "do_if", 3, 1, "valid_operands", True, 6, False, "1264694304272145", l_tc.exception_trace_string)					
			l_tc.setup
			retrieve_pre_state (l_tc.operands)
			l_tc.generated_test_1
			retrieve_post_state (l_tc.operands)
		end
	rescue
		exception_count := exception_count + 1
		l_retried := True
		retry
	end

	execute_test_case_7
	local
		l_tc: TC__DS_ARRAYED_LIST__do_if__S__c0__b0__REC_DS_ARRAYED_LIST__do_if__TAG_noname__126468787641716
		l_retried: BOOLEAN
	do
		if not l_retried then
			create l_tc
			mark_test_case ("DS_INDEXABLE", "do_if", 3, 1, "valid_operands", True, 7, False, "126468787641716", l_tc.exception_trace_string)					
			l_tc.setup
			retrieve_pre_state (l_tc.operands)
			l_tc.generated_test_1
			retrieve_post_state (l_tc.operands)
		end
	rescue
		exception_count := exception_count + 1
		l_retried := True
		retry
	end

	execute_test_case_8
	local
		l_tc: TC__DS_ARRAYED_LIST__do_if__S__c0__b0__REC_DS_ARRAYED_LIST__do_if__TAG_noname__12646926501248582
		l_retried: BOOLEAN
	do
		if not l_retried then
			create l_tc
			mark_test_case ("DS_INDEXABLE", "do_if", 3, 1, "valid_operands", True, 8, False, "12646926501248582", l_tc.exception_trace_string)					
			l_tc.setup
			retrieve_pre_state (l_tc.operands)
			l_tc.generated_test_1
			retrieve_post_state (l_tc.operands)
		end
	rescue
		exception_count := exception_count + 1
		l_retried := True
		retry
	end

	execute_test_case_9
	local
		l_tc: TC__DS_ARRAYED_LIST__do_if__S__c0__b0__REC_DS_ARRAYED_LIST__do_if__TAG_noname__126468787843663
		l_retried: BOOLEAN
	do
		if not l_retried then
			create l_tc
			mark_test_case ("DS_INDEXABLE", "do_if", 3, 1, "valid_operands", True, 9, False, "126468787843663", l_tc.exception_trace_string)					
			l_tc.setup
			retrieve_pre_state (l_tc.operands)
			l_tc.generated_test_1
			retrieve_post_state (l_tc.operands)
		end
	rescue
		exception_count := exception_count + 1
		l_retried := True
		retry
	end

	execute_test_case_10
	local
		l_tc: TC__DS_ARRAYED_LIST__do_if__S__c0__b0__REC_DS_ARRAYED_LIST__do_if__TAG_noname__126468787439816
		l_retried: BOOLEAN
	do
		if not l_retried then
			create l_tc
			mark_test_case ("DS_INDEXABLE", "do_if", 3, 1, "valid_operands", True, 10, False, "126468787439816", l_tc.exception_trace_string)					
			l_tc.setup
			retrieve_pre_state (l_tc.operands)
			l_tc.generated_test_1
			retrieve_post_state (l_tc.operands)
		end
	rescue
		exception_count := exception_count + 1
		l_retried := True
		retry
	end



end
