class
	APPLICATION
	
inherit
	AFX_INTERPRETER
	
create
	make
		
		
feature{NONE} -- Implementation

	mark_test_case (a_recipient_class: STRING; a_recipient: STRING; a_exception_code: INTEGER; a_bpslot: INTEGER; a_tag: STRING; a_passing: BOOLEAN; a_test_case_number: INTEGER; a_dry_run: BOOLEAN; a_uuid: STRING; a_trace: STRING)
			-- If `a_dry_run' is True, states of the current system should not be retrieved.
		do
			do_nothing
		end

	initialize_test_cases
			-- Initialize `test_cases'.
		do
			create test_cases.make (12)
			test_cases.compare_objects
			test_cases.extend (agent execute_test_case_2, "12646922321013657")
			test_cases.extend (agent execute_test_case_3, "12646926331236049")
			test_cases.extend (agent execute_test_case_4, "1264688042207150")
			test_cases.extend (agent execute_test_case_5, "12646963121087562")
			test_cases.extend (agent execute_test_case_6, "126468787742530")
			test_cases.extend (agent execute_test_case_7, "12646922531029720")
			test_cases.extend (agent execute_test_case_8, "126468786027348")
			test_cases.extend (agent execute_test_case_9, "12646922371017390")
			test_cases.extend (agent execute_test_case_10, "12646922431021816")
			test_cases.extend (agent execute_test_case_11, "12646922301011874")
			test_cases.extend (agent execute_test_case_12, "1264688049214039")
			test_cases.extend (agent execute_test_case_13, "12646962971084435")
		end


	operand_states (a_operands: SPECIAL [detachable ANY]):  like state_type
		local
			l_queries: HASH_TABLE [HASH_TABLE [FUNCTION [ANY, TUPLE, ANY], STRING], INTEGER]
			l_tbl: HASH_TABLE [FUNCTION [ANY, TUPLE, ANY], STRING]
		do
			create l_queries.make (a_operands.count)
			if attached {DS_ARRAYED_LIST [?ANY]} a_operands.item (0) as l_operand_0 then
				create l_tbl.make (12)
				l_tbl.compare_objects
				l_queries.put (l_tbl, 0)
				l_tbl.put (agent l_operand_0.after, "after")
				l_tbl.put (agent l_operand_0.before, "before")
				l_tbl.put (agent l_operand_0.capacity, "capacity")
				l_tbl.put (agent l_operand_0.count, "count")
				l_tbl.put (agent l_operand_0.default_capacity, "default_capacity")
				l_tbl.put (agent l_operand_0.has_void, "has_void")
				l_tbl.put (agent l_operand_0.index, "index")
				l_tbl.put (agent l_operand_0.is_empty, "is_empty")
				l_tbl.put (agent l_operand_0.is_first, "is_first")
				l_tbl.put (agent l_operand_0.is_full, "is_full")
				l_tbl.put (agent l_operand_0.is_last, "is_last")
				l_tbl.put (agent l_operand_0.off, "off")
			else
				create l_tbl.make (0)
				l_tbl.compare_objects
				l_queries.put (l_tbl, 0)
			end
			if attached {INTEGER_32} a_operands.item (1) as l_operand_1 then
				create l_tbl.make (1)
				l_tbl.compare_objects
				l_queries.put (l_tbl, 1)
				l_tbl.put (agent (l_value: INTEGER_32): INTEGER_32 do Result := l_value end (l_operand_1), "item")
			else
				create l_tbl.make (0)
				l_tbl.compare_objects
				l_queries.put (l_tbl, 1)
			end
			if attached {DS_ARRAYED_LIST_CURSOR [?ANY]} a_operands.item (2) as l_operand_2 then
				create l_tbl.make (6)
				l_tbl.compare_objects
				l_queries.put (l_tbl, 2)
				l_tbl.put (agent l_operand_2.after, "after")
				l_tbl.put (agent l_operand_2.before, "before")
				l_tbl.put (agent l_operand_2.index, "index")
				l_tbl.put (agent l_operand_2.is_first, "is_first")
				l_tbl.put (agent l_operand_2.is_last, "is_last")
				l_tbl.put (agent l_operand_2.off, "off")
			else
				create l_tbl.make (0)
				l_tbl.compare_objects
				l_queries.put (l_tbl, 2)
			end
			Result := object_states (l_queries)
		end


	first_failing_test_case_uuid: STRING
		do
			Result := "12646922321013657"
		end



	execute_test_cases
			--Execute test cases.
		do
			execute_test_case_1
			execute_test_case_2
			execute_test_case_3
			execute_test_case_4
			execute_test_case_5
			execute_test_case_6
			execute_test_case_7
			execute_test_case_8
			execute_test_case_9
			execute_test_case_10
			execute_test_case_11
			execute_test_case_12
			execute_test_case_13
		end


feature{NONE} -- Implementation

	execute_test_case_1
	local
		l_tc: TC__DS_ARRAYED_LIST__prune_right__F__c3__b1__REC_DS_ARRAYED_LIST__prune_right_cursor__TAG_valid_index__12646922321013657
		l_retried: BOOLEAN
	do
		if not l_retried then
			create l_tc
			mark_test_case ("DS_ARRAYED_LIST", "prune_right_cursor", 3, 1, "valid_index", False, 1, True, "12646922321013657", l_tc.exception_trace_string)					
			l_tc.setup
			retrieve_pre_state (l_tc.operands)
			l_tc.generated_test_1
			retrieve_post_state (l_tc.operands)
		end
	rescue
		exception_count := exception_count + 1
		l_retried := True
		retry
	end

	execute_test_case_2
	local
		l_tc: TC__DS_ARRAYED_LIST__prune_right__F__c3__b1__REC_DS_ARRAYED_LIST__prune_right_cursor__TAG_valid_index__12646922321013657
		l_retried: BOOLEAN
	do
		if not l_retried then
			create l_tc
			mark_test_case ("DS_ARRAYED_LIST", "prune_right_cursor", 3, 1, "valid_index", False, 2, False, "12646922321013657", l_tc.exception_trace_string)					
			l_tc.setup
			retrieve_pre_state (l_tc.operands)
			l_tc.generated_test_1
			retrieve_post_state (l_tc.operands)
		end
	rescue
		exception_count := exception_count + 1
		l_retried := True
		retry
	end

	execute_test_case_3
	local
		l_tc: TC__DS_ARRAYED_LIST__prune_right__F__c3__b1__REC_DS_ARRAYED_LIST__prune_right_cursor__TAG_valid_index__12646926331236049
		l_retried: BOOLEAN
	do
		if not l_retried then
			create l_tc
			mark_test_case ("DS_ARRAYED_LIST", "prune_right_cursor", 3, 1, "valid_index", False, 3, False, "12646926331236049", l_tc.exception_trace_string)					
			l_tc.setup
			retrieve_pre_state (l_tc.operands)
			l_tc.generated_test_1
			retrieve_post_state (l_tc.operands)
		end
	rescue
		exception_count := exception_count + 1
		l_retried := True
		retry
	end

	execute_test_case_4
	local
		l_tc: TC__DS_ARRAYED_LIST__prune_right__F__c3__b1__REC_DS_ARRAYED_LIST__prune_right_cursor__TAG_valid_index__1264688042207150
		l_retried: BOOLEAN
	do
		if not l_retried then
			create l_tc
			mark_test_case ("DS_ARRAYED_LIST", "prune_right_cursor", 3, 1, "valid_index", False, 4, False, "1264688042207150", l_tc.exception_trace_string)					
			l_tc.setup
			retrieve_pre_state (l_tc.operands)
			l_tc.generated_test_1
			retrieve_post_state (l_tc.operands)
		end
	rescue
		exception_count := exception_count + 1
		l_retried := True
		retry
	end

	execute_test_case_5
	local
		l_tc: TC__DS_ARRAYED_LIST__prune_right__F__c3__b1__REC_DS_ARRAYED_LIST__prune_right_cursor__TAG_valid_index__12646963121087562
		l_retried: BOOLEAN
	do
		if not l_retried then
			create l_tc
			mark_test_case ("DS_ARRAYED_LIST", "prune_right_cursor", 3, 1, "valid_index", False, 5, False, "12646963121087562", l_tc.exception_trace_string)					
			l_tc.setup
			retrieve_pre_state (l_tc.operands)
			l_tc.generated_test_1
			retrieve_post_state (l_tc.operands)
		end
	rescue
		exception_count := exception_count + 1
		l_retried := True
		retry
	end

	execute_test_case_6
	local
		l_tc: TC__DS_ARRAYED_LIST__prune_right__F__c3__b1__REC_DS_ARRAYED_LIST__prune_right_cursor__TAG_valid_index__126468787742530
		l_retried: BOOLEAN
	do
		if not l_retried then
			create l_tc
			mark_test_case ("DS_ARRAYED_LIST", "prune_right_cursor", 3, 1, "valid_index", False, 6, False, "126468787742530", l_tc.exception_trace_string)					
			l_tc.setup
			retrieve_pre_state (l_tc.operands)
			l_tc.generated_test_1
			retrieve_post_state (l_tc.operands)
		end
	rescue
		exception_count := exception_count + 1
		l_retried := True
		retry
	end

	execute_test_case_7
	local
		l_tc: TC__DS_ARRAYED_LIST__prune_right__S__c0__b0__REC_DS_ARRAYED_LIST__prune_right__TAG_noname__12646922531029720
		l_retried: BOOLEAN
	do
		if not l_retried then
			create l_tc
			mark_test_case ("DS_ARRAYED_LIST", "prune_right_cursor", 3, 1, "valid_index", True, 7, False, "12646922531029720", l_tc.exception_trace_string)					
			l_tc.setup
			retrieve_pre_state (l_tc.operands)
			l_tc.generated_test_1
			retrieve_post_state (l_tc.operands)
		end
	rescue
		exception_count := exception_count + 1
		l_retried := True
		retry
	end

	execute_test_case_8
	local
		l_tc: TC__DS_ARRAYED_LIST__prune_right__S__c0__b0__REC_DS_ARRAYED_LIST__prune_right__TAG_noname__126468786027348
		l_retried: BOOLEAN
	do
		if not l_retried then
			create l_tc
			mark_test_case ("DS_ARRAYED_LIST", "prune_right_cursor", 3, 1, "valid_index", True, 8, False, "126468786027348", l_tc.exception_trace_string)					
			l_tc.setup
			retrieve_pre_state (l_tc.operands)
			l_tc.generated_test_1
			retrieve_post_state (l_tc.operands)
		end
	rescue
		exception_count := exception_count + 1
		l_retried := True
		retry
	end

	execute_test_case_9
	local
		l_tc: TC__DS_ARRAYED_LIST__prune_right__S__c0__b0__REC_DS_ARRAYED_LIST__prune_right__TAG_noname__12646922371017390
		l_retried: BOOLEAN
	do
		if not l_retried then
			create l_tc
			mark_test_case ("DS_ARRAYED_LIST", "prune_right_cursor", 3, 1, "valid_index", True, 9, False, "12646922371017390", l_tc.exception_trace_string)					
			l_tc.setup
			retrieve_pre_state (l_tc.operands)
			l_tc.generated_test_1
			retrieve_post_state (l_tc.operands)
		end
	rescue
		exception_count := exception_count + 1
		l_retried := True
		retry
	end

	execute_test_case_10
	local
		l_tc: TC__DS_ARRAYED_LIST__prune_right__S__c0__b0__REC_DS_ARRAYED_LIST__prune_right__TAG_noname__12646922431021816
		l_retried: BOOLEAN
	do
		if not l_retried then
			create l_tc
			mark_test_case ("DS_ARRAYED_LIST", "prune_right_cursor", 3, 1, "valid_index", True, 10, False, "12646922431021816", l_tc.exception_trace_string)					
			l_tc.setup
			retrieve_pre_state (l_tc.operands)
			l_tc.generated_test_1
			retrieve_post_state (l_tc.operands)
		end
	rescue
		exception_count := exception_count + 1
		l_retried := True
		retry
	end

	execute_test_case_11
	local
		l_tc: TC__DS_ARRAYED_LIST__prune_right__S__c0__b0__REC_DS_ARRAYED_LIST__prune_right__TAG_noname__12646922301011874
		l_retried: BOOLEAN
	do
		if not l_retried then
			create l_tc
			mark_test_case ("DS_ARRAYED_LIST", "prune_right_cursor", 3, 1, "valid_index", True, 11, False, "12646922301011874", l_tc.exception_trace_string)					
			l_tc.setup
			retrieve_pre_state (l_tc.operands)
			l_tc.generated_test_1
			retrieve_post_state (l_tc.operands)
		end
	rescue
		exception_count := exception_count + 1
		l_retried := True
		retry
	end

	execute_test_case_12
	local
		l_tc: TC__DS_ARRAYED_LIST__prune_right__S__c0__b0__REC_DS_ARRAYED_LIST__prune_right__TAG_noname__1264688049214039
		l_retried: BOOLEAN
	do
		if not l_retried then
			create l_tc
			mark_test_case ("DS_ARRAYED_LIST", "prune_right_cursor", 3, 1, "valid_index", True, 12, False, "1264688049214039", l_tc.exception_trace_string)					
			l_tc.setup
			retrieve_pre_state (l_tc.operands)
			l_tc.generated_test_1
			retrieve_post_state (l_tc.operands)
		end
	rescue
		exception_count := exception_count + 1
		l_retried := True
		retry
	end

	execute_test_case_13
	local
		l_tc: TC__DS_ARRAYED_LIST__prune_right__S__c0__b0__REC_DS_ARRAYED_LIST__prune_right__TAG_noname__12646962971084435
		l_retried: BOOLEAN
	do
		if not l_retried then
			create l_tc
			mark_test_case ("DS_ARRAYED_LIST", "prune_right_cursor", 3, 1, "valid_index", True, 13, False, "12646962971084435", l_tc.exception_trace_string)					
			l_tc.setup
			retrieve_pre_state (l_tc.operands)
			l_tc.generated_test_1
			retrieve_post_state (l_tc.operands)
		end
	rescue
		exception_count := exception_count + 1
		l_retried := True
		retry
	end



end
