class
	APPLICATION
	
inherit
	AFX_INTERPRETER
	
create
	make
		
		
feature{NONE} -- Implementation

	mark_test_case (a_recipient_class: STRING; a_recipient: STRING; a_exception_code: INTEGER; a_bpslot: INTEGER; a_tag: STRING; a_passing: BOOLEAN; a_test_case_number: INTEGER; a_dry_run: BOOLEAN; a_uuid: STRING; a_trace: STRING)
			-- If `a_dry_run' is True, states of the current system should not be retrieved.
		do
			do_nothing
		end

	initialize_test_cases
			-- Initialize `test_cases'.
		do
			create test_cases.make (19)
			test_cases.compare_objects
			test_cases.extend (agent execute_test_case_2, "12646965321170923")
			test_cases.extend (agent execute_test_case_3, "1264688343479097")
			test_cases.extend (agent execute_test_case_4, "12646928261362893")
			test_cases.extend (agent execute_test_case_5, "1264695478744404")
			test_cases.extend (agent execute_test_case_6, "12646894591382402")
			test_cases.extend (agent execute_test_case_7, "12646928071347275")
			test_cases.extend (agent execute_test_case_8, "1264688342478029")
			test_cases.extend (agent execute_test_case_9, "12646928061346698")
			test_cases.extend (agent execute_test_case_10, "12646928021344739")
			test_cases.extend (agent execute_test_case_11, "1264695507757581")
			test_cases.extend (agent execute_test_case_12, "12646894541377872")
			test_cases.extend (agent execute_test_case_13, "12646928241360922")
			test_cases.extend (agent execute_test_case_14, "12646928241361010")
			test_cases.extend (agent execute_test_case_15, "12646894621384795")
			test_cases.extend (agent execute_test_case_16, "1264695486747077")
			test_cases.extend (agent execute_test_case_17, "12646925551196149")
			test_cases.extend (agent execute_test_case_18, "1264695488747849")
			test_cases.extend (agent execute_test_case_19, "1264695491749327")
			test_cases.extend (agent execute_test_case_20, "12646894551379370")
		end


	operand_states (a_operands: SPECIAL [detachable ANY]):  like state_type
		local
			l_queries: HASH_TABLE [HASH_TABLE [FUNCTION [ANY, TUPLE, ANY], STRING], INTEGER]
			l_tbl: HASH_TABLE [FUNCTION [ANY, TUPLE, ANY], STRING]
		do
			create l_queries.make (a_operands.count)
			if attached {TWO_WAY_SORTED_SET [COMPARABLE]} a_operands.item (0) as l_operand_0 then
				create l_tbl.make (18)
				l_tbl.compare_objects
				l_queries.put (l_tbl, 0)
				l_tbl.put (agent l_operand_0.after, "after")
				l_tbl.put (agent l_operand_0.before, "before")
				l_tbl.put (agent l_operand_0.changeable_comparison_criterion, "changeable_comparison_criterion")
				l_tbl.put (agent l_operand_0.count, "count")
				l_tbl.put (agent l_operand_0.empty, "empty")
				l_tbl.put (agent l_operand_0.exhausted, "exhausted")
				l_tbl.put (agent l_operand_0.extendible, "extendible")
				l_tbl.put (agent l_operand_0.full, "full")
				l_tbl.put (agent l_operand_0.index, "index")
				l_tbl.put (agent l_operand_0.is_empty, "is_empty")
				l_tbl.put (agent l_operand_0.isfirst, "isfirst")
				l_tbl.put (agent l_operand_0.islast, "islast")
				l_tbl.put (agent l_operand_0.object_comparison, "object_comparison")
				l_tbl.put (agent l_operand_0.off, "off")
				l_tbl.put (agent l_operand_0.prunable, "prunable")
				l_tbl.put (agent l_operand_0.readable, "readable")
				l_tbl.put (agent l_operand_0.sorted, "sorted")
				l_tbl.put (agent l_operand_0.writable, "writable")
			else
				create l_tbl.make (0)
				l_tbl.compare_objects
				l_queries.put (l_tbl, 0)
			end
			if attached {TWO_WAY_SORTED_SET [COMPARABLE]} a_operands.item (1) as l_operand_1 then
				create l_tbl.make (18)
				l_tbl.compare_objects
				l_queries.put (l_tbl, 1)
				l_tbl.put (agent l_operand_1.after, "after")
				l_tbl.put (agent l_operand_1.before, "before")
				l_tbl.put (agent l_operand_1.changeable_comparison_criterion, "changeable_comparison_criterion")
				l_tbl.put (agent l_operand_1.count, "count")
				l_tbl.put (agent l_operand_1.empty, "empty")
				l_tbl.put (agent l_operand_1.exhausted, "exhausted")
				l_tbl.put (agent l_operand_1.extendible, "extendible")
				l_tbl.put (agent l_operand_1.full, "full")
				l_tbl.put (agent l_operand_1.index, "index")
				l_tbl.put (agent l_operand_1.is_empty, "is_empty")
				l_tbl.put (agent l_operand_1.isfirst, "isfirst")
				l_tbl.put (agent l_operand_1.islast, "islast")
				l_tbl.put (agent l_operand_1.object_comparison, "object_comparison")
				l_tbl.put (agent l_operand_1.off, "off")
				l_tbl.put (agent l_operand_1.prunable, "prunable")
				l_tbl.put (agent l_operand_1.readable, "readable")
				l_tbl.put (agent l_operand_1.sorted, "sorted")
				l_tbl.put (agent l_operand_1.writable, "writable")
			else
				create l_tbl.make (0)
				l_tbl.compare_objects
				l_queries.put (l_tbl, 1)
			end
			Result := object_states (l_queries)
		end


	first_failing_test_case_uuid: STRING
		do
			Result := "12646965321170923"
		end



	execute_test_cases
			--Execute test cases.
		do
			execute_test_case_1
			execute_test_case_2
			execute_test_case_3
			execute_test_case_4
			execute_test_case_5
			execute_test_case_6
			execute_test_case_7
			execute_test_case_8
			execute_test_case_9
			execute_test_case_10
			execute_test_case_11
			execute_test_case_12
			execute_test_case_13
			execute_test_case_14
			execute_test_case_15
			execute_test_case_16
			execute_test_case_17
			execute_test_case_18
			execute_test_case_19
			execute_test_case_20
		end


feature{NONE} -- Implementation

	execute_test_case_1
	local
		l_tc: TC__TWO_WAY_SORTED_SET__intersect__F__c3__b1__REC_TWO_WAY_SORTED_SET__intersect__TAG_not_after__12646965321170923
		l_retried: BOOLEAN
	do
		if not l_retried then
			create l_tc
			mark_test_case ("TWO_WAY_SORTED_SET", "intersect", 3, 1, "not_after", False, 1, True, "12646965321170923", l_tc.exception_trace_string)					
			l_tc.setup
			retrieve_pre_state (l_tc.operands)
			l_tc.generated_test_1
			retrieve_post_state (l_tc.operands)
		end
	rescue
		exception_count := exception_count + 1
		l_retried := True
		retry
	end

	execute_test_case_2
	local
		l_tc: TC__TWO_WAY_SORTED_SET__intersect__F__c3__b1__REC_TWO_WAY_SORTED_SET__intersect__TAG_not_after__12646965321170923
		l_retried: BOOLEAN
	do
		if not l_retried then
			create l_tc
			mark_test_case ("TWO_WAY_SORTED_SET", "intersect", 3, 1, "not_after", False, 2, False, "12646965321170923", l_tc.exception_trace_string)					
			l_tc.setup
			retrieve_pre_state (l_tc.operands)
			l_tc.generated_test_1
			retrieve_post_state (l_tc.operands)
		end
	rescue
		exception_count := exception_count + 1
		l_retried := True
		retry
	end

	execute_test_case_3
	local
		l_tc: TC__TWO_WAY_SORTED_SET__intersect__F__c3__b1__REC_TWO_WAY_SORTED_SET__intersect__TAG_not_after__1264688343479097
		l_retried: BOOLEAN
	do
		if not l_retried then
			create l_tc
			mark_test_case ("TWO_WAY_SORTED_SET", "intersect", 3, 1, "not_after", False, 3, False, "1264688343479097", l_tc.exception_trace_string)					
			l_tc.setup
			retrieve_pre_state (l_tc.operands)
			l_tc.generated_test_1
			retrieve_post_state (l_tc.operands)
		end
	rescue
		exception_count := exception_count + 1
		l_retried := True
		retry
	end

	execute_test_case_4
	local
		l_tc: TC__TWO_WAY_SORTED_SET__intersect__F__c3__b1__REC_TWO_WAY_SORTED_SET__intersect__TAG_not_after__12646928261362893
		l_retried: BOOLEAN
	do
		if not l_retried then
			create l_tc
			mark_test_case ("TWO_WAY_SORTED_SET", "intersect", 3, 1, "not_after", False, 4, False, "12646928261362893", l_tc.exception_trace_string)					
			l_tc.setup
			retrieve_pre_state (l_tc.operands)
			l_tc.generated_test_1
			retrieve_post_state (l_tc.operands)
		end
	rescue
		exception_count := exception_count + 1
		l_retried := True
		retry
	end

	execute_test_case_5
	local
		l_tc: TC__TWO_WAY_SORTED_SET__intersect__S__c0__b0__REC_TWO_WAY_SORTED_SET__intersect__TAG_noname__1264695478744404
		l_retried: BOOLEAN
	do
		if not l_retried then
			create l_tc
			mark_test_case ("TWO_WAY_SORTED_SET", "intersect", 3, 1, "not_after", True, 5, False, "1264695478744404", l_tc.exception_trace_string)					
			l_tc.setup
			retrieve_pre_state (l_tc.operands)
			l_tc.generated_test_1
			retrieve_post_state (l_tc.operands)
		end
	rescue
		exception_count := exception_count + 1
		l_retried := True
		retry
	end

	execute_test_case_6
	local
		l_tc: TC__TWO_WAY_SORTED_SET__intersect__S__c0__b0__REC_TWO_WAY_SORTED_SET__intersect__TAG_noname__12646894591382402
		l_retried: BOOLEAN
	do
		if not l_retried then
			create l_tc
			mark_test_case ("TWO_WAY_SORTED_SET", "intersect", 3, 1, "not_after", True, 6, False, "12646894591382402", l_tc.exception_trace_string)					
			l_tc.setup
			retrieve_pre_state (l_tc.operands)
			l_tc.generated_test_1
			retrieve_post_state (l_tc.operands)
		end
	rescue
		exception_count := exception_count + 1
		l_retried := True
		retry
	end

	execute_test_case_7
	local
		l_tc: TC__TWO_WAY_SORTED_SET__intersect__S__c0__b0__REC_TWO_WAY_SORTED_SET__intersect__TAG_noname__12646928071347275
		l_retried: BOOLEAN
	do
		if not l_retried then
			create l_tc
			mark_test_case ("TWO_WAY_SORTED_SET", "intersect", 3, 1, "not_after", True, 7, False, "12646928071347275", l_tc.exception_trace_string)					
			l_tc.setup
			retrieve_pre_state (l_tc.operands)
			l_tc.generated_test_1
			retrieve_post_state (l_tc.operands)
		end
	rescue
		exception_count := exception_count + 1
		l_retried := True
		retry
	end

	execute_test_case_8
	local
		l_tc: TC__TWO_WAY_SORTED_SET__intersect__S__c0__b0__REC_TWO_WAY_SORTED_SET__intersect__TAG_noname__1264688342478029
		l_retried: BOOLEAN
	do
		if not l_retried then
			create l_tc
			mark_test_case ("TWO_WAY_SORTED_SET", "intersect", 3, 1, "not_after", True, 8, False, "1264688342478029", l_tc.exception_trace_string)					
			l_tc.setup
			retrieve_pre_state (l_tc.operands)
			l_tc.generated_test_1
			retrieve_post_state (l_tc.operands)
		end
	rescue
		exception_count := exception_count + 1
		l_retried := True
		retry
	end

	execute_test_case_9
	local
		l_tc: TC__TWO_WAY_SORTED_SET__intersect__S__c0__b0__REC_TWO_WAY_SORTED_SET__intersect__TAG_noname__12646928061346698
		l_retried: BOOLEAN
	do
		if not l_retried then
			create l_tc
			mark_test_case ("TWO_WAY_SORTED_SET", "intersect", 3, 1, "not_after", True, 9, False, "12646928061346698", l_tc.exception_trace_string)					
			l_tc.setup
			retrieve_pre_state (l_tc.operands)
			l_tc.generated_test_1
			retrieve_post_state (l_tc.operands)
		end
	rescue
		exception_count := exception_count + 1
		l_retried := True
		retry
	end

	execute_test_case_10
	local
		l_tc: TC__TWO_WAY_SORTED_SET__intersect__S__c0__b0__REC_TWO_WAY_SORTED_SET__intersect__TAG_noname__12646928021344739
		l_retried: BOOLEAN
	do
		if not l_retried then
			create l_tc
			mark_test_case ("TWO_WAY_SORTED_SET", "intersect", 3, 1, "not_after", True, 10, False, "12646928021344739", l_tc.exception_trace_string)					
			l_tc.setup
			retrieve_pre_state (l_tc.operands)
			l_tc.generated_test_1
			retrieve_post_state (l_tc.operands)
		end
	rescue
		exception_count := exception_count + 1
		l_retried := True
		retry
	end

	execute_test_case_11
	local
		l_tc: TC__TWO_WAY_SORTED_SET__intersect__S__c0__b0__REC_TWO_WAY_SORTED_SET__intersect__TAG_noname__1264695507757581
		l_retried: BOOLEAN
	do
		if not l_retried then
			create l_tc
			mark_test_case ("TWO_WAY_SORTED_SET", "intersect", 3, 1, "not_after", True, 11, False, "1264695507757581", l_tc.exception_trace_string)					
			l_tc.setup
			retrieve_pre_state (l_tc.operands)
			l_tc.generated_test_1
			retrieve_post_state (l_tc.operands)
		end
	rescue
		exception_count := exception_count + 1
		l_retried := True
		retry
	end

	execute_test_case_12
	local
		l_tc: TC__TWO_WAY_SORTED_SET__intersect__S__c0__b0__REC_TWO_WAY_SORTED_SET__intersect__TAG_noname__12646894541377872
		l_retried: BOOLEAN
	do
		if not l_retried then
			create l_tc
			mark_test_case ("TWO_WAY_SORTED_SET", "intersect", 3, 1, "not_after", True, 12, False, "12646894541377872", l_tc.exception_trace_string)					
			l_tc.setup
			retrieve_pre_state (l_tc.operands)
			l_tc.generated_test_1
			retrieve_post_state (l_tc.operands)
		end
	rescue
		exception_count := exception_count + 1
		l_retried := True
		retry
	end

	execute_test_case_13
	local
		l_tc: TC__TWO_WAY_SORTED_SET__intersect__S__c0__b0__REC_TWO_WAY_SORTED_SET__intersect__TAG_noname__12646928241360922
		l_retried: BOOLEAN
	do
		if not l_retried then
			create l_tc
			mark_test_case ("TWO_WAY_SORTED_SET", "intersect", 3, 1, "not_after", True, 13, False, "12646928241360922", l_tc.exception_trace_string)					
			l_tc.setup
			retrieve_pre_state (l_tc.operands)
			l_tc.generated_test_1
			retrieve_post_state (l_tc.operands)
		end
	rescue
		exception_count := exception_count + 1
		l_retried := True
		retry
	end

	execute_test_case_14
	local
		l_tc: TC__TWO_WAY_SORTED_SET__intersect__S__c0__b0__REC_TWO_WAY_SORTED_SET__intersect__TAG_noname__12646928241361010
		l_retried: BOOLEAN
	do
		if not l_retried then
			create l_tc
			mark_test_case ("TWO_WAY_SORTED_SET", "intersect", 3, 1, "not_after", True, 14, False, "12646928241361010", l_tc.exception_trace_string)					
			l_tc.setup
			retrieve_pre_state (l_tc.operands)
			l_tc.generated_test_1
			retrieve_post_state (l_tc.operands)
		end
	rescue
		exception_count := exception_count + 1
		l_retried := True
		retry
	end

	execute_test_case_15
	local
		l_tc: TC__TWO_WAY_SORTED_SET__intersect__S__c0__b0__REC_TWO_WAY_SORTED_SET__intersect__TAG_noname__12646894621384795
		l_retried: BOOLEAN
	do
		if not l_retried then
			create l_tc
			mark_test_case ("TWO_WAY_SORTED_SET", "intersect", 3, 1, "not_after", True, 15, False, "12646894621384795", l_tc.exception_trace_string)					
			l_tc.setup
			retrieve_pre_state (l_tc.operands)
			l_tc.generated_test_1
			retrieve_post_state (l_tc.operands)
		end
	rescue
		exception_count := exception_count + 1
		l_retried := True
		retry
	end

	execute_test_case_16
	local
		l_tc: TC__TWO_WAY_SORTED_SET__intersect__S__c0__b0__REC_TWO_WAY_SORTED_SET__intersect__TAG_noname__1264695486747077
		l_retried: BOOLEAN
	do
		if not l_retried then
			create l_tc
			mark_test_case ("TWO_WAY_SORTED_SET", "intersect", 3, 1, "not_after", True, 16, False, "1264695486747077", l_tc.exception_trace_string)					
			l_tc.setup
			retrieve_pre_state (l_tc.operands)
			l_tc.generated_test_1
			retrieve_post_state (l_tc.operands)
		end
	rescue
		exception_count := exception_count + 1
		l_retried := True
		retry
	end

	execute_test_case_17
	local
		l_tc: TC__TWO_WAY_SORTED_SET__intersect__S__c0__b0__REC_TWO_WAY_SORTED_SET__intersect__TAG_noname__12646925551196149
		l_retried: BOOLEAN
	do
		if not l_retried then
			create l_tc
			mark_test_case ("TWO_WAY_SORTED_SET", "intersect", 3, 1, "not_after", True, 17, False, "12646925551196149", l_tc.exception_trace_string)					
			l_tc.setup
			retrieve_pre_state (l_tc.operands)
			l_tc.generated_test_1
			retrieve_post_state (l_tc.operands)
		end
	rescue
		exception_count := exception_count + 1
		l_retried := True
		retry
	end

	execute_test_case_18
	local
		l_tc: TC__TWO_WAY_SORTED_SET__intersect__S__c0__b0__REC_TWO_WAY_SORTED_SET__intersect__TAG_noname__1264695488747849
		l_retried: BOOLEAN
	do
		if not l_retried then
			create l_tc
			mark_test_case ("TWO_WAY_SORTED_SET", "intersect", 3, 1, "not_after", True, 18, False, "1264695488747849", l_tc.exception_trace_string)					
			l_tc.setup
			retrieve_pre_state (l_tc.operands)
			l_tc.generated_test_1
			retrieve_post_state (l_tc.operands)
		end
	rescue
		exception_count := exception_count + 1
		l_retried := True
		retry
	end

	execute_test_case_19
	local
		l_tc: TC__TWO_WAY_SORTED_SET__intersect__S__c0__b0__REC_TWO_WAY_SORTED_SET__intersect__TAG_noname__1264695491749327
		l_retried: BOOLEAN
	do
		if not l_retried then
			create l_tc
			mark_test_case ("TWO_WAY_SORTED_SET", "intersect", 3, 1, "not_after", True, 19, False, "1264695491749327", l_tc.exception_trace_string)					
			l_tc.setup
			retrieve_pre_state (l_tc.operands)
			l_tc.generated_test_1
			retrieve_post_state (l_tc.operands)
		end
	rescue
		exception_count := exception_count + 1
		l_retried := True
		retry
	end

	execute_test_case_20
	local
		l_tc: TC__TWO_WAY_SORTED_SET__intersect__S__c0__b0__REC_TWO_WAY_SORTED_SET__intersect__TAG_noname__12646894551379370
		l_retried: BOOLEAN
	do
		if not l_retried then
			create l_tc
			mark_test_case ("TWO_WAY_SORTED_SET", "intersect", 3, 1, "not_after", True, 20, False, "12646894551379370", l_tc.exception_trace_string)					
			l_tc.setup
			retrieve_pre_state (l_tc.operands)
			l_tc.generated_test_1
			retrieve_post_state (l_tc.operands)
		end
	rescue
		exception_count := exception_count + 1
		l_retried := True
		retry
	end



end
