class
	APPLICATION
	
inherit
	AFX_INTERPRETER
	
create
	make
		
		
feature{NONE} -- Implementation

	mark_test_case (a_recipient_class: STRING; a_recipient: STRING; a_exception_code: INTEGER; a_bpslot: INTEGER; a_tag: STRING; a_passing: BOOLEAN; a_test_case_number: INTEGER; a_dry_run: BOOLEAN; a_uuid: STRING; a_trace: STRING)
			-- If `a_dry_run' is True, states of the current system should not be retrieved.
		do
			do_nothing
		end

	initialize_test_cases
			-- Initialize `test_cases'.
		do
			create test_cases.make (15)
			test_cases.compare_objects
			test_cases.extend (agent execute_test_case_2, "12646925281178401")
			test_cases.extend (agent execute_test_case_3, "12646925491191043")
			test_cases.extend (agent execute_test_case_4, "12646925501191726")
			test_cases.extend (agent execute_test_case_5, "1264688326460623")
			test_cases.extend (agent execute_test_case_6, "12646928121350148")
			test_cases.extend (agent execute_test_case_7, "12646925391183412")
			test_cases.extend (agent execute_test_case_8, "12646928261363541")
			test_cases.extend (agent execute_test_case_9, "1264688343479701")
			test_cases.extend (agent execute_test_case_10, "1264688340475942")
			test_cases.extend (agent execute_test_case_11, "12646925521193200")
			test_cases.extend (agent execute_test_case_12, "1264695501755237")
			test_cases.extend (agent execute_test_case_13, "1264695500754299")
			test_cases.extend (agent execute_test_case_14, "1264688334469007")
			test_cases.extend (agent execute_test_case_15, "12646925421185153")
			test_cases.extend (agent execute_test_case_16, "12646894691392753")
		end


	operand_states (a_operands: SPECIAL [detachable ANY]):  like state_type
		local
			l_queries: HASH_TABLE [HASH_TABLE [FUNCTION [ANY, TUPLE, ANY], STRING], INTEGER]
			l_tbl: HASH_TABLE [FUNCTION [ANY, TUPLE, ANY], STRING]
		do
			create l_queries.make (a_operands.count)
			if attached {TWO_WAY_SORTED_SET [COMPARABLE]} a_operands.item (0) as l_operand_0 then
				create l_tbl.make (18)
				l_tbl.compare_objects
				l_queries.put (l_tbl, 0)
				l_tbl.put (agent l_operand_0.after, "after")
				l_tbl.put (agent l_operand_0.before, "before")
				l_tbl.put (agent l_operand_0.changeable_comparison_criterion, "changeable_comparison_criterion")
				l_tbl.put (agent l_operand_0.count, "count")
				l_tbl.put (agent l_operand_0.empty, "empty")
				l_tbl.put (agent l_operand_0.exhausted, "exhausted")
				l_tbl.put (agent l_operand_0.extendible, "extendible")
				l_tbl.put (agent l_operand_0.full, "full")
				l_tbl.put (agent l_operand_0.index, "index")
				l_tbl.put (agent l_operand_0.is_empty, "is_empty")
				l_tbl.put (agent l_operand_0.isfirst, "isfirst")
				l_tbl.put (agent l_operand_0.islast, "islast")
				l_tbl.put (agent l_operand_0.object_comparison, "object_comparison")
				l_tbl.put (agent l_operand_0.off, "off")
				l_tbl.put (agent l_operand_0.prunable, "prunable")
				l_tbl.put (agent l_operand_0.readable, "readable")
				l_tbl.put (agent l_operand_0.sorted, "sorted")
				l_tbl.put (agent l_operand_0.writable, "writable")
			else
				create l_tbl.make (0)
				l_tbl.compare_objects
				l_queries.put (l_tbl, 0)
			end
			if attached {TWO_WAY_SORTED_SET [COMPARABLE]} a_operands.item (1) as l_operand_1 then
				create l_tbl.make (18)
				l_tbl.compare_objects
				l_queries.put (l_tbl, 1)
				l_tbl.put (agent l_operand_1.after, "after")
				l_tbl.put (agent l_operand_1.before, "before")
				l_tbl.put (agent l_operand_1.changeable_comparison_criterion, "changeable_comparison_criterion")
				l_tbl.put (agent l_operand_1.count, "count")
				l_tbl.put (agent l_operand_1.empty, "empty")
				l_tbl.put (agent l_operand_1.exhausted, "exhausted")
				l_tbl.put (agent l_operand_1.extendible, "extendible")
				l_tbl.put (agent l_operand_1.full, "full")
				l_tbl.put (agent l_operand_1.index, "index")
				l_tbl.put (agent l_operand_1.is_empty, "is_empty")
				l_tbl.put (agent l_operand_1.isfirst, "isfirst")
				l_tbl.put (agent l_operand_1.islast, "islast")
				l_tbl.put (agent l_operand_1.object_comparison, "object_comparison")
				l_tbl.put (agent l_operand_1.off, "off")
				l_tbl.put (agent l_operand_1.prunable, "prunable")
				l_tbl.put (agent l_operand_1.readable, "readable")
				l_tbl.put (agent l_operand_1.sorted, "sorted")
				l_tbl.put (agent l_operand_1.writable, "writable")
			else
				create l_tbl.make (0)
				l_tbl.compare_objects
				l_queries.put (l_tbl, 1)
			end
			Result := object_states (l_queries)
		end


	first_failing_test_case_uuid: STRING
		do
			Result := "12646925281178401"
		end



	execute_test_cases
			--Execute test cases.
		do
			execute_test_case_1
			execute_test_case_2
			execute_test_case_3
			execute_test_case_4
			execute_test_case_5
			execute_test_case_6
			execute_test_case_7
			execute_test_case_8
			execute_test_case_9
			execute_test_case_10
			execute_test_case_11
			execute_test_case_12
			execute_test_case_13
			execute_test_case_14
			execute_test_case_15
			execute_test_case_16
		end


feature{NONE} -- Implementation

	execute_test_case_1
	local
		l_tc: TC__TWO_WAY_SORTED_SET__subtract__F__c3__b1__REC_TWO_WAY_SORTED_SET__subtract__TAG_not_after__12646925281178401
		l_retried: BOOLEAN
	do
		if not l_retried then
			create l_tc
			mark_test_case ("TWO_WAY_SORTED_SET", "subtract", 3, 1, "not_after", False, 1, True, "12646925281178401", l_tc.exception_trace_string)					
			l_tc.setup
			retrieve_pre_state (l_tc.operands)
			l_tc.generated_test_1
			retrieve_post_state (l_tc.operands)
		end
	rescue
		exception_count := exception_count + 1
		l_retried := True
		retry
	end

	execute_test_case_2
	local
		l_tc: TC__TWO_WAY_SORTED_SET__subtract__F__c3__b1__REC_TWO_WAY_SORTED_SET__subtract__TAG_not_after__12646925281178401
		l_retried: BOOLEAN
	do
		if not l_retried then
			create l_tc
			mark_test_case ("TWO_WAY_SORTED_SET", "subtract", 3, 1, "not_after", False, 2, False, "12646925281178401", l_tc.exception_trace_string)					
			l_tc.setup
			retrieve_pre_state (l_tc.operands)
			l_tc.generated_test_1
			retrieve_post_state (l_tc.operands)
		end
	rescue
		exception_count := exception_count + 1
		l_retried := True
		retry
	end

	execute_test_case_3
	local
		l_tc: TC__TWO_WAY_SORTED_SET__subtract__F__c3__b1__REC_TWO_WAY_SORTED_SET__subtract__TAG_not_after__12646925491191043
		l_retried: BOOLEAN
	do
		if not l_retried then
			create l_tc
			mark_test_case ("TWO_WAY_SORTED_SET", "subtract", 3, 1, "not_after", False, 3, False, "12646925491191043", l_tc.exception_trace_string)					
			l_tc.setup
			retrieve_pre_state (l_tc.operands)
			l_tc.generated_test_1
			retrieve_post_state (l_tc.operands)
		end
	rescue
		exception_count := exception_count + 1
		l_retried := True
		retry
	end

	execute_test_case_4
	local
		l_tc: TC__TWO_WAY_SORTED_SET__subtract__S__c0__b0__REC_TWO_WAY_SORTED_SET__subtract__TAG_noname__12646925501191726
		l_retried: BOOLEAN
	do
		if not l_retried then
			create l_tc
			mark_test_case ("TWO_WAY_SORTED_SET", "subtract", 3, 1, "not_after", True, 4, False, "12646925501191726", l_tc.exception_trace_string)					
			l_tc.setup
			retrieve_pre_state (l_tc.operands)
			l_tc.generated_test_1
			retrieve_post_state (l_tc.operands)
		end
	rescue
		exception_count := exception_count + 1
		l_retried := True
		retry
	end

	execute_test_case_5
	local
		l_tc: TC__TWO_WAY_SORTED_SET__subtract__S__c0__b0__REC_TWO_WAY_SORTED_SET__subtract__TAG_noname__1264688326460623
		l_retried: BOOLEAN
	do
		if not l_retried then
			create l_tc
			mark_test_case ("TWO_WAY_SORTED_SET", "subtract", 3, 1, "not_after", True, 5, False, "1264688326460623", l_tc.exception_trace_string)					
			l_tc.setup
			retrieve_pre_state (l_tc.operands)
			l_tc.generated_test_1
			retrieve_post_state (l_tc.operands)
		end
	rescue
		exception_count := exception_count + 1
		l_retried := True
		retry
	end

	execute_test_case_6
	local
		l_tc: TC__TWO_WAY_SORTED_SET__subtract__S__c0__b0__REC_TWO_WAY_SORTED_SET__subtract__TAG_noname__12646928121350148
		l_retried: BOOLEAN
	do
		if not l_retried then
			create l_tc
			mark_test_case ("TWO_WAY_SORTED_SET", "subtract", 3, 1, "not_after", True, 6, False, "12646928121350148", l_tc.exception_trace_string)					
			l_tc.setup
			retrieve_pre_state (l_tc.operands)
			l_tc.generated_test_1
			retrieve_post_state (l_tc.operands)
		end
	rescue
		exception_count := exception_count + 1
		l_retried := True
		retry
	end

	execute_test_case_7
	local
		l_tc: TC__TWO_WAY_SORTED_SET__subtract__S__c0__b0__REC_TWO_WAY_SORTED_SET__subtract__TAG_noname__12646925391183412
		l_retried: BOOLEAN
	do
		if not l_retried then
			create l_tc
			mark_test_case ("TWO_WAY_SORTED_SET", "subtract", 3, 1, "not_after", True, 7, False, "12646925391183412", l_tc.exception_trace_string)					
			l_tc.setup
			retrieve_pre_state (l_tc.operands)
			l_tc.generated_test_1
			retrieve_post_state (l_tc.operands)
		end
	rescue
		exception_count := exception_count + 1
		l_retried := True
		retry
	end

	execute_test_case_8
	local
		l_tc: TC__TWO_WAY_SORTED_SET__subtract__S__c0__b0__REC_TWO_WAY_SORTED_SET__subtract__TAG_noname__12646928261363541
		l_retried: BOOLEAN
	do
		if not l_retried then
			create l_tc
			mark_test_case ("TWO_WAY_SORTED_SET", "subtract", 3, 1, "not_after", True, 8, False, "12646928261363541", l_tc.exception_trace_string)					
			l_tc.setup
			retrieve_pre_state (l_tc.operands)
			l_tc.generated_test_1
			retrieve_post_state (l_tc.operands)
		end
	rescue
		exception_count := exception_count + 1
		l_retried := True
		retry
	end

	execute_test_case_9
	local
		l_tc: TC__TWO_WAY_SORTED_SET__subtract__S__c0__b0__REC_TWO_WAY_SORTED_SET__subtract__TAG_noname__1264688343479701
		l_retried: BOOLEAN
	do
		if not l_retried then
			create l_tc
			mark_test_case ("TWO_WAY_SORTED_SET", "subtract", 3, 1, "not_after", True, 9, False, "1264688343479701", l_tc.exception_trace_string)					
			l_tc.setup
			retrieve_pre_state (l_tc.operands)
			l_tc.generated_test_1
			retrieve_post_state (l_tc.operands)
		end
	rescue
		exception_count := exception_count + 1
		l_retried := True
		retry
	end

	execute_test_case_10
	local
		l_tc: TC__TWO_WAY_SORTED_SET__subtract__S__c0__b0__REC_TWO_WAY_SORTED_SET__subtract__TAG_noname__1264688340475942
		l_retried: BOOLEAN
	do
		if not l_retried then
			create l_tc
			mark_test_case ("TWO_WAY_SORTED_SET", "subtract", 3, 1, "not_after", True, 10, False, "1264688340475942", l_tc.exception_trace_string)					
			l_tc.setup
			retrieve_pre_state (l_tc.operands)
			l_tc.generated_test_1
			retrieve_post_state (l_tc.operands)
		end
	rescue
		exception_count := exception_count + 1
		l_retried := True
		retry
	end

	execute_test_case_11
	local
		l_tc: TC__TWO_WAY_SORTED_SET__subtract__S__c0__b0__REC_TWO_WAY_SORTED_SET__subtract__TAG_noname__12646925521193200
		l_retried: BOOLEAN
	do
		if not l_retried then
			create l_tc
			mark_test_case ("TWO_WAY_SORTED_SET", "subtract", 3, 1, "not_after", True, 11, False, "12646925521193200", l_tc.exception_trace_string)					
			l_tc.setup
			retrieve_pre_state (l_tc.operands)
			l_tc.generated_test_1
			retrieve_post_state (l_tc.operands)
		end
	rescue
		exception_count := exception_count + 1
		l_retried := True
		retry
	end

	execute_test_case_12
	local
		l_tc: TC__TWO_WAY_SORTED_SET__subtract__S__c0__b0__REC_TWO_WAY_SORTED_SET__subtract__TAG_noname__1264695501755237
		l_retried: BOOLEAN
	do
		if not l_retried then
			create l_tc
			mark_test_case ("TWO_WAY_SORTED_SET", "subtract", 3, 1, "not_after", True, 12, False, "1264695501755237", l_tc.exception_trace_string)					
			l_tc.setup
			retrieve_pre_state (l_tc.operands)
			l_tc.generated_test_1
			retrieve_post_state (l_tc.operands)
		end
	rescue
		exception_count := exception_count + 1
		l_retried := True
		retry
	end

	execute_test_case_13
	local
		l_tc: TC__TWO_WAY_SORTED_SET__subtract__S__c0__b0__REC_TWO_WAY_SORTED_SET__subtract__TAG_noname__1264695500754299
		l_retried: BOOLEAN
	do
		if not l_retried then
			create l_tc
			mark_test_case ("TWO_WAY_SORTED_SET", "subtract", 3, 1, "not_after", True, 13, False, "1264695500754299", l_tc.exception_trace_string)					
			l_tc.setup
			retrieve_pre_state (l_tc.operands)
			l_tc.generated_test_1
			retrieve_post_state (l_tc.operands)
		end
	rescue
		exception_count := exception_count + 1
		l_retried := True
		retry
	end

	execute_test_case_14
	local
		l_tc: TC__TWO_WAY_SORTED_SET__subtract__S__c0__b0__REC_TWO_WAY_SORTED_SET__subtract__TAG_noname__1264688334469007
		l_retried: BOOLEAN
	do
		if not l_retried then
			create l_tc
			mark_test_case ("TWO_WAY_SORTED_SET", "subtract", 3, 1, "not_after", True, 14, False, "1264688334469007", l_tc.exception_trace_string)					
			l_tc.setup
			retrieve_pre_state (l_tc.operands)
			l_tc.generated_test_1
			retrieve_post_state (l_tc.operands)
		end
	rescue
		exception_count := exception_count + 1
		l_retried := True
		retry
	end

	execute_test_case_15
	local
		l_tc: TC__TWO_WAY_SORTED_SET__subtract__S__c0__b0__REC_TWO_WAY_SORTED_SET__subtract__TAG_noname__12646925421185153
		l_retried: BOOLEAN
	do
		if not l_retried then
			create l_tc
			mark_test_case ("TWO_WAY_SORTED_SET", "subtract", 3, 1, "not_after", True, 15, False, "12646925421185153", l_tc.exception_trace_string)					
			l_tc.setup
			retrieve_pre_state (l_tc.operands)
			l_tc.generated_test_1
			retrieve_post_state (l_tc.operands)
		end
	rescue
		exception_count := exception_count + 1
		l_retried := True
		retry
	end

	execute_test_case_16
	local
		l_tc: TC__TWO_WAY_SORTED_SET__subtract__S__c0__b0__REC_TWO_WAY_SORTED_SET__subtract__TAG_noname__12646894691392753
		l_retried: BOOLEAN
	do
		if not l_retried then
			create l_tc
			mark_test_case ("TWO_WAY_SORTED_SET", "subtract", 3, 1, "not_after", True, 16, False, "12646894691392753", l_tc.exception_trace_string)					
			l_tc.setup
			retrieve_pre_state (l_tc.operands)
			l_tc.generated_test_1
			retrieve_post_state (l_tc.operands)
		end
	rescue
		exception_count := exception_count + 1
		l_retried := True
		retry
	end



end
